

(function() {

	var IM;
	IM = this.IM = {};

	IM.formWidth	= 300;
	IM.formHeight	= 500;
	IM.widgetWidth	= 200;
	IM.widgetHeight = 100;
	
	IM.dataUrl = 'info.html';
	
	/**
	 * general
	 */
	IM.mode = false; // false = off, true = on


	/**
	 * edit mode button
	 */
	IM.buttonId = "btnInfoMode";
	IM.wrappingObject = '#widgetContainer';
	IM.btn = null;

	IM.buttonCSSProperties = {
		position : 'absolute',
		top : '0px',
		right : '0px',
	};

	IM.html = "";
	
	/**
	 * edit mode form
	 */
	IM.formType = 'L'; // L, M, S wie Kleidergrössen


	/**
	 * functions....
	 */
	IM.showInfo = function() {

		IM.mode = true;
		$(IM.wrappingObject).hide();
		
		var widget = KBBUTIL.getWidgetObject();
		widget.width = IM.formWidth;
		widget.height = IM.formHeight;
		$('body').css('width', IM.formWidth);
		$('body').css('height', IM.formHeight);

		$('.infoModeFormWrapper').show();
	};

	
	IM.hideInfo = function() {

		IM.mode = false;
		$('.infoModeFormWrapper').hide();
		
		if(kbb.widgetName == "WidgetViewer") {
			
			$(IM.wrappingObject).show();
			kbb.initFromPersistance();
KBBUTIL.log("IM.hideInfo");			
			return;
		}
		
		var widget = KBBUTIL.getWidgetObject();
		widget.width = IM.widgetWidth;
		widget.height = IM.widgetHeight;
		
		$('body').css('width', IM.widgetWidth);
		$('body').css('height', IM.widgetHeight);
		
		$(IM.wrappingObject).show();
	};
	
	
	IM.addEvents = function() {
		
		IM.btn.click(function() {

			if (IM.mode === false)
				IM.showInfo();
			else
				IM.hideInfo();
		});
		
		$('.infoModeFormWrapper').click(function() {

			IM.hideInfo();
		});
		
	};
	
	
	IM.setSizes = function() {
		
		var size = KBBUTIL.infoModeSize;
		
		IM.formWidth = KBBUTIL.infoModeSizes[size].width;
		IM.formHeight = KBBUTIL.infoModeSizes[size].height;
		IM.widgetWidth = kbb.widgetWidth;
		IM.widgetHeight = kbb.widgetHeight;
	};
	
	
	IM.addButton = function() {

		$('<a id="' + IM.buttonId + '"> </a>').appendTo($(IM.wrappingObject));
		IM.btn = $('#' + IM.buttonId);
	};

	IM.createView = function() {
		
		var html = '';

		html += '<div class="infoModeFormWrapper size' + IM.formType + 
			'" style="display:none">' + 
			'<div class="header"><span rel="localize">Info Mode</span></div>' +
			'<div class="infoContent">' +
			IM.html + '</div>' +
			'<div id="madeby"><a href="http://www.KBundB.de/smartwidgets.html?utm_source=smart&utm_medium=widget&utm_campaign='+ 
			kbb.widgetName +'" target="_blank"><img src="data/made_by_KBB.png" border="0" /></a></div>'
			;

		$(IM.wrappingObject).after(html);
		
		IM.addButton();
		
		IM.addEvents();
		IM.setSizes();
	};
	
	
	
	IM.fetchData = function() {
		
		var dataUrl = IM.dataUrl;
		
		if (kbb.locale != "en") {

			dataUrl = "locales/" + kbb.locale + "/info.html";
		}


		$.ajax({
			url: dataUrl,
			success: function(data) { 
				
				KBBUTIL.log("ajax success "+ dataUrl +" "+ data);
				IM.html = data;
				//NEXT STEP
				IM.createView(); 
			},
			error: function() { 

				KBBUTIL.log("fetch .error "+ dataUrl);
				//NO FILE FOUND, ok, then load fallback			
				$.ajax({
					url: IM.dataUrl, 
					success: function(data) {
						
						KBBUTIL.log("ajax success "+ dataUrl +" "+ data);
						
						IM.html = data;
						//NEXT STEP
						IM.createView();
					},
					error: function() {
				
						//NO INFO FOUND, NO INFOMODE
						KBBUTIL.log("fallback fetch .error "+ IM.dataUrl);
					}
				});
			}
		});	
	};


	IM.init = function() {

KBBUTIL.log("IM.fetchData();");		
		IM.fetchData();
	};

	
	IM.init();
})();
