/**
 * 1. Daten holen 2. Daten parsen 3. View aufbauen 4. View Funktionalität 5. los
 */

;
(function($) {

	var kbb;
	kbb = this.kbb = {};
	kbb.widgetName = "ShowRandomWords";
	
	kbb.editModeSize = 'L';
	kbb.infoModeSize = 'L';
	
	kbb.locale = "en";
	kbb.dataPath = "data/";
	kbb.items = ["Smart", "Notebook", "Cherry", "Tomato", "Dog", "Bug", "Curry", "Feet"];
	kbb.startElement = 0;
	
	kbb.randomNum = 1;
	kbb.widgetWidth = 320;
	kbb.widgetHeight = 460;
	
	kbb.smartTextProperties = {x:100, y:200 };

	kbb.html = "";
	kbb.posTopLabelOne = 190;
	kbb.glue = "<br>";
	
	kbb.editModeFormElements = [ {
		type : 'list',
		label : 'Words',
		name : 'words',
		initial : ''
	}, {
		type : 'button',
		name : 'getAllTexts',
		label : 'Fetch all Textobjects',
		onclick : kbb.getAllTexts,
		className : 'btnLong'
	}, {
		type : 'line'
	}, {
		type : 'slider',
		name : 'amountPerTurn',
		label : 'How many words per click?',
		sliderMin: 1,
		sliderMax: 6,
		initial: 1			
	}, {
		type : 'line'
	}, {
		type : 'okCancel',
		okName : 'saveForm',
		cancelName : 'cancelForm'
	}

	];
	
	kbb.cancelForm = function() {
		
		EM.hideForm();
	};
	
	
	kbb.editMode = function() {
		
		KBBUTIL.editModeSize = kbb.editModeSize;
		KBBUTIL.addEditMode(kbb.editModeFormElements);
		KBBUTIL.infoModeSize = kbb.infoModeSize;
		KBBUTIL.addInfoMode();
	};
	
	
	kbb.initFromPersistance = function() {
	
		var randNumOld = kbb.randomNum;
		KBBUTIL.log("kbb.initFromPersistance "+ randNumOld);
		
		kbb.randomNum = KBBUTIL.load('amountPerTurn');
		
		if(KBBUTIL.load('words') == "") {
			
			kbb.items = new Array();
			$('#labelWord').html("no words");
			return;
		}
		
		kbb.items = KBBUTIL.stringToArray(KBBUTIL.load('words'), ',');
		
		if(kbb.randomNum > kbb.items.length) {
			
			kbb.randomNum = kbb.items.length;
			KBBUTIL.save('amountPerTurn', kbb.randomNum);
		}
		
		kbb.randomNum = (isNaN(kbb.randomNum)) ? 1 : kbb.randomNum;
		$('#widgetContainer').css('background-image', 'url(' + kbb.dataPath + 'dog_' + kbb.randomNum + '.png)');
		
		
		/*
		 * */
		var randomWords = KBBUTIL.load("randomWords");
		if(randomWords != "not-found" && randNumOld === kbb.randomNum) {
			
			$('#labelWord').html(randomWords);
		} else { 
			
			kbb.setRandomWord();	
		}
		
		var widget = KBBUTIL.getWidgetObject();
		widget.width = kbb.widgetWidth;
		widget.height = kbb.widgetHeight;
		$('body').css('width', kbb.widgetWidth);
		$('body').css('height', kbb.widgetHeight);		
	};
	
	
	kbb.getAllTexts = function() {
	
		KBBUTIL.log("kbb.getAllTexts()");		
		
		var objects = KBBUTIL.getAllTextPageObjects();
		var words = KBBUTIL.load("words");

		
		for(var i=0; i<objects.length; i++) {
			
			var texts = objects[i].text.split("\n");
			
			for(var j=0; j<texts.length; j++) {

			        texts[j] = texts[j].replace("\r" , "");
			
				if(KBBUTIL.inArray(texts[j], kbb.items) === false) {
					
					var text = '<span>'+ texts[j] +'</span><a class="deleteRow"><img src="data/editmode-trashcan-15px.png" border="0"></a><div class="clearer"></div>';
					var $li = $('<li class="ui-state-default" />').html(text);
					$('.listingWrapper .sortable').append($li).sortable('refresh')				
					.promise()
					.done(function() {
	
						$('.listingWrapper').css('border', '1px solid #ffc85a');
						setTimeout("EMFE.sortableBorderReset()", 500);
					});
					
					words += "," + texts[j];
				}
			}
		}
		
		$('.listingWrapper .sortable').scrollTo('max');
		
		$('.deleteRow').click(function() {
			
			$(this).parent().remove();			
		});

	};
	

	
	kbb.addEvents = function() {

		KBBUTIL.log("kbb.addEvents");

		$('.stageWrapper').click(function() {

			kbb.setRandomWord();
		});
		
		
		$('#btnExtract').click(function() {
			
			if(kbb.items.length < 1) {
				
				return;
			}	
			
			
			var wordHtml = $('#labelWord').html();
			var words = wordHtml.split(kbb.glue);
			
			for(var i=0; i<words.length; i++) {
				
				var prototype = KBBUTIL.createTextObject(words[i], kbb.smartTextProperties);
				NB.addObject(prototype);
			}
		});

		
		NB.addObserver("dndDropEvent", function(evt) {

	/*		if(EM.mode == true) {
				
				for ( var guid in evt.eventData) {
					
					var chk = NB.getObject(guid);

					if(chk.text === undefined || KBBUTIL.inArray(chk.text, kbb.items) === true)
						return;
					
					if (NB.getHostObject().contains(chk.x, chk.y)) {
						
						var words = KBBUTIL.load("words");
						words += "," + chk.text;
						
						KBBUTIL.load("words ["+chk.text+"] " +words);					
						KBBUTIL.save("words", words);
						
						kbb.initFromPersistance();
					}
				}				
			}			
*/
		});
		
		
		// NEXT AND LAST STEP
		//KBBWIDGETSETUP.localizeText(kbb.locale);
		kbb.initFromPersistance();
		KBBUTIL.moveToBack();
	};


	kbb.getRandomNum = function() {

//		KBBUTIL.log("kbb.items.length "+ kbb.items.length);
		if(kbb.items.length < 1) {
			
			return;
		}	
		
		var min = 0;
		var max = kbb.items.length - 1;

//		KBBUTIL.log("kbb.getRandomNum " + min + " < " + max);

		if (min == max)
			return min;

		var r;

		do {
			r = Math.random();
		} while (r == 1.0);

		return min + parseInt(r * (max - min + 1));
	};


	kbb.setRandomWord = function() {

//		KBBUTIL.log("kbb.getRandomWord()");

//		KBBUTIL.log("kbb.items.length "+ kbb.items.length);
		if(kbb.items.length < 1) {
			
			return;
		}		
		
		var num = kbb.getRandomNum();
		var randomWord = kbb.items[num];
		var storage = new Array();

		while(storage.length < kbb.randomNum) {

			num = kbb.getRandomNum();
			randomWord = kbb.items[num];
			
			if(KBBUTIL.inArray(randomWord, storage)) continue;
				
			storage.push(randomWord);
		}
		
		if(kbb.randomNum == 6)
			posTop = kbb.posTopLabelOne - 20;
		else
			posTop = kbb.posTopLabelOne;

		
		$('#labelWord').css('top', posTop);
		
		randomWords = storage.join(kbb.glue);
		
		KBBUTIL.save("randomWords", randomWords);
		$('#widget').appendTo("randomWords", randomWords);
		
		kbb.changeWordLetterFading(randomWords);

	};


	kbb.changeWordLetterFading = function(randomWord) {

		$("#labelWord span").each(function() {

			$(this).fadeOut();
		}).promise().done(function() {

			$("#labelWord span").each(function() {

				$(this).remove();
			}).promise().done(function() {

				kbb.changeWord(randomWord);
			});

		});

	};


	kbb.changeWord = function(randomWord) {

		KBBUTIL.log("kbb.changeWord()");

		var word = "";

		word = randomWord;

		if (word == 'not-found') word=NB.localize("Empty list");
		$('#labelWord').html(word);

	};

	kbb.getViewStage = function() {

		KBBUTIL.log("kbb.getViewStage");


		var html =  
			'<div id="display">' + 
			'<article class="stageWrapper">' + 
			'<label id="labelWord"></label>' +
			'</article>' +
			'<button id="btnExtract"> </button>' +
			'</div>';


		return html;
	};


	kbb.createView = function() {

		KBBUTIL.log("kbb.createView");

		kbb.html = '<section class="container">' + 
				kbb.getViewStage() +
				'</section>';
		kbb.element.html(kbb.html).removeClass("preloader");

		kbb.editMode();

		$('#widget').addClass(kbb.widgetName);
		
		// NEXT STEP
		kbb.addEvents();
	};

	
	$.fn.startUP = function(locale) {

		kbb.locale = locale;
		kbb.element = $(this);

//		KBBUTIL.save('words', KBBUTIL.arrayToString(kbb.items, ','));
//		KBBUTIL.save('words', "");
		
		// NEXT STEP
		kbb.createView();
		NB.localization.translateHtmlElements();
	};


})(jQuery);


$('#widgetContainer').startUP(locale);